Autocad

Font một nét shx Unicode cho AutoCad

Sử dụng font một nét trong AutoCad có nhiều lợi ích như tạo ra bản vẽ nhẹ và có thể điều chỉnh chiều dày nét chữ …Khó khăn hiện nay là có rất ít font một nét có thể gõ được kiểu Unicode dựng sẵn trong Autocad. Do đó mình đã phát triển font một nét này dựa trên bộ font có sẵn iso3098b. Cá nhân mình thấy bộ font này đẹp và có một số tiêu chuẩn nước ngoài sử dụng nó.

LISP tách layout thành từng bản vẽ riêng biệt

Mình thường nhận được một bản vẽ Autocad với nhiều bản vẽ trên nhiều layout khác nhau. Vì quản lý bản vẽ bằng Sheet Set Manager nên mình phải làm công việc sắp xếp lại và tách chúng ra thành những bản vẽ riêng biệt. Mỗi bản vẽ nằm trên một layout. Có vài ba LISP thực hiện việc này nhưng sau một thời gian sử dụng và kiểm thử mình sử dụng đoạn LISP bên dưới.

LISP xóa đối tượng không nằm trong viewport của layout

Sau khi tách các bản vẽ nằm trên những layout khác nhau, mình dùng LISP này để xóa những đối tượng không nằm trong viewport của layout để giảm nhẹ dung lượng bản vẽ. Công dụng - Xóa các đối tượng không nằm trong viewport của layout (defun c:DelObjectsNotOnAnyViewport () (setq ssview (ssadd)) (setvar 'ctab "MODEL") (setq app (vlax-get-acad-object)) (vlax-for lay ; for each layout (vla-get-layouts (vla-get-activedocument (vlax-get-acad-object))) (setq id1 nil) ; ignore the first vp (if (eq :vlax-false (vla-get-modeltype lay)) (progn (vlax-for obj (vla-get-block lay) ; for each obj in layout (if (and (= (vla-get-objectname obj) "AcDbViewport") (or id1 (not (setq id1 t))) ; ignore first viewport because that is the viewport tab itself ) (progn (vla-GetBoundingBox obj 'LPVP 'UPVP) (setq LPVP (vlax-safearray->list LPVP)) (setq UPVP (vlax-safearray->list UPVP)) (setq LPMODEL (PCS2WCS LPVP (vlax-vla-object->ename obj))) (setq UPMODEL (PCS2WCS UPVP (vlax-vla-object->ename obj))) (setq minx (car LPMODEL)) (setq maxx (car UPMODEL)) (setq miny (cadr LPMODEL)) (setq maxy (cadr UPMODEL)) (setq pt1 (list minx miny)) (setq pt2 (list maxx miny)) (setq pt3 (list maxx maxy)) (setq pt4 (list minx maxy)) (vla-zoomwindow app (vlax-3d-point pt1) (vlax-3d-point pt3)) (if (setq ss (ssget "_CP" (list pt1 pt2 pt3 pt4) (list (cons 410 "MODEL")))) (setq ssview (kdub:ssunion ssview ss)) ) ) ) ) ) ) ) (setq ssall (ssget "_X" (list (cons 410 "MODEL")))) (setq sstodel (kdub:sssubtract ssall ssview)) (repeat (setq n (sslength sstodel)) (setq ent (ssname sstodel (setq n (1- n)))) (entdel ent)) ) ;;; Union of two selection sets (defun kdub:ssunion (ss1 ss2 / ss index) ;;; Source : http://www.

Lisp lấy tọa độ tương đối của một điểm so với điểm trước đó

Trong quá trình viết font tiếng việt một nét cho AutoCad tôi gặp phải vấn đề là lấy tọa độ tương đối của một điểm so với điểm trước đó. Dưới đây là đoạn LISP thực hiện chức năng đó. File đính kèm tải bên dưới ;;;RELATIVE COORDINATE === lay toa do tuong doi cua mot diem so voi diem truoc do (defun C:RC () (setvar "hpbound" 1) (setvar "cmdecho" 1) (setq pnt1 (getpoint "\nPick datum point: ")) ;;;(setq ref1 (getpoint "\nEnter datum elevation of cross section:")) ;;; (setq ref1 (getreal "\nEnter datum elevation of cross section:")) ;_ it is a real (setq p1x (car pnt1)) ;;x coord (setq p1y (cadr pnt1)) ;;y coord (while (setq pnt2 (getpoint "\nPick coordinate point: ")) (setq p2x (car pnt2)) ;;x coord (setq p2y (cadr pnt2)) ;;y coord ;;(setq dx (rtos (- (p1x p2x)) 2 2)) ;; it shall be so ;;;(setq dx (rtos (- p1x p2x) 2 2)) dong comment nay cua file goc (setq dx (rtos (- p2x p1x) 2 2)) ;;(setq dy (rtos (+ ((- (p1y p2y)) ref1)) 2 2)) ;; it shall be so ;;; (setq dy (rtos (+ (- p1y p2y) ref1) 2 2)) dong comment nay cua file goc (setq dy (rtos (- p2y p1y) 2 2)) ;;(setq STDZ (rtos P1z 2 2)) (setq COORDN (strcat "Y " dy)) (setq COORDE (strcat "X " dx)) ;;(setq COORDZ (strcat "Z " STDZ )) (setq PTXT (getpoint "\nPick text location: ")) (command "LEADER" pnt2 PTXT "" COORDE COORDN "") ) ;while (princ) )